---
title: "FreeBSD 15.0-RELEASE Release Notes"
sidenav: download
---

:localRel: 15.0
:releaseCurrent: 15.0-RELEASE
:releaseBranch: 15-STABLE
:releasePrev: 14.0-RELEASE
:releaseNext: 15.1-RELEASE
:releaseType: "release"

include::shared/en/urls.adoc[]

= FreeBSD {releaseCurrent} Release Notes
:doctype: article
:toc: macro
:toclevels: 1
:icons: font

== Abstract

[.abstract-title]
The release notes for FreeBSD {releaseCurrent} contain a summary of the changes made to the FreeBSD base system on the {releaseBranch} development line.
This document lists applicable security advisories that were issued since the last release, as well as significant changes to the FreeBSD kernel and userland.
Some brief remarks on upgrading are also presented.

[[intro]]
== Introduction

This document contains the release notes for FreeBSD {releaseCurrent}.
It describes recently added, changed, or deleted features of FreeBSD.
It also provides some notes on upgrading from previous versions of FreeBSD.

The {releaseType} distribution to which these release notes apply represents the latest point along the {releaseBranch} development branch since {releaseBranch} was created.
Information regarding pre-built, binary {releaseType} distributions along this branch can be found at https://www.FreeBSD.org/releases/[].

The {releaseType} distribution to which these release notes apply represents a point along the {releaseBranch} development branch between {releasePrev} and the future {releaseNext}.
Information regarding pre-built, binary {releaseType} distributions along this branch can be found at https://www.FreeBSD.org/releases/[].

This distribution of FreeBSD {releaseCurrent} is a {releaseType} distribution.
It can be found at https://www.FreeBSD.org/releases/[] or any of its mirrors.
More information on obtaining this (or other) {releaseType} distributions of FreeBSD can be found in the link:{handbook}/mirrors[Obtaining FreeBSD appendix] to the link:{handbook}/[FreeBSD Handbook].

All users are encouraged to consult the release errata before installing FreeBSD.
The errata document is updated with "late-breaking" information discovered late in the release cycle or after the release.
Typically, it contains information on known bugs, security advisories, and corrections to documentation.
An up-to-date copy of the errata for FreeBSD {releaseCurrent} can be found on the FreeBSD Web site.

This document describes the most user-visible new or changed features in FreeBSD since {releasePrev}.
In general, changes described here are unique to the {releaseBranch} branch unless specifically marked as MERGED features.

Typical release note items document recent security advisories issued after {releasePrev}, new drivers or hardware support, new commands or options, major bug fixes, or contributed software upgrades.
They may also list changes to major ports/packages or release engineering practices.
Clearly the release notes cannot list every single change made to FreeBSD between releases; this document focuses primarily on security advisories, user-visible changes, and major architectural improvements.

[[upgrade]]
== Upgrading from Previous Releases of FreeBSD

NOTE: FreeBSD Update is probably not going to exist in {releaseCurrent}!
The text below is boilerplate from previous releases and should be replaced with instructions for using pkgbase once those are finalized.

Binary upgrades between RELEASE versions (and snapshots of the various security branches) are supported using the man:freebsd-update[8] utility.
See the release-specific upgrade procedure, link:../installation/#upgrade-binary[FreeBSD {releaseCurrent} upgrade information], with more details in the FreeBSD handbook link:{handbook}cutting-edge/#freebsdupdate-upgrade[binary upgrade procedure].
This will update unmodified userland utilities, as well as unmodified GENERIC kernels distributed as a part of an official FreeBSD release.
The man:freebsd-update[8] utility requires that the host being upgraded have Internet connectivity.

Source-based upgrades (those based on recompiling the FreeBSD base system from source code) from previous versions are supported, according to the instructions in [.filename]#/usr/src/UPDATING#.

[IMPORTANT]
====
Upgrading FreeBSD should only be attempted after backing up _all_ data and configuration files.
====

[[security-errata]]
== Security and Errata

This section lists the various Security Advisories and Errata Notices since {releasePrev}.

[[security]]
=== Security Advisories

[.informaltable]
[cols="1,1,1", frame="none", options="header"]
|===
| Advisory
| Date
| Topic

|https://www.freebsd.org/security/advisories/FreeBSD-SA-23:17.pf.asc[FreeBSD-SA-23:17.pf]
|05 December 2023
|TCP spoofing vulnerability in man:pf[4]

|https://www.freebsd.org/security/advisories/FreeBSD-SA-23:18.nfsclient.asc[FreeBSD-SA-23:18.nfsclient]
|12 December 2023
|NFS client data corruption and kernel memory disclosure

|https://www.freebsd.org/security/advisories/FreeBSD-SA-23:19.openssh.asc[FreeBSD-SA-23:19.openssh]
|19 December 2023
|Prefix Truncation Attack in the SSH protocol

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:01.bhyveload.asc[FreeBSD-SA-24:01.bhyveload]
|14 February 2024
|man:bhyveload[8] host file access

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:02.tty.asc[FreeBSD-SA-24:02.tty]
|14 February 2024
|man:jail[2] information leak

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:03.unbound.asc[FreeBSD-SA-24:03.unbound]
|28 March 2024
|Multiple vulnerabilities in unbound

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:04.openssh.asc[FreeBSD-SA-24:04.openssh]
|01 July 2024
|OpenSSH pre-authentication remote code execution

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:05.pf.asc[FreeBSD-SA-24:05.pf]
|07 August 2024
|pf incorrectly matches different ICMPv6 states in the state table

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:06.ktrace.asc[FreeBSD-SA-24:06.ktrace]
|07 August 2024
|man:ktrace[2] fails to detach when executing a setuid binary

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:07.nfsclient.asc[FreeBSD-SA-24:07.nfsclient]
|07 August 2024
|NFS client accepts file names containing path separators

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:08.openssh.asc[FreeBSD-SA-24:08.openssh]
|07 August 2024
|OpenSSH pre-authentication async signal safety issue

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:09.libnv.asc[FreeBSD-SA-24:09.libnv]
|04 September 2024
|Multiple vulnerabilities in libnv

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:10.bhyve.asc[FreeBSD-SA-24:10.bhyve]
|04 September 2024
|man:bhyve[8] privileged guest escape via TPM device passthrough

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:11.ctl.asc[FreeBSD-SA-24:11.ctl]
|04 September 2024
|Multiple issues in man:ctl[4] CAM Target Layer

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:12.bhyve.asc[FreeBSD-SA-24:12.bhyve]
|04 September 2024
|man:bhyve[8] privileged guest escape via USB controller

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:13.openssl.asc[FreeBSD-SA-24:13.openssl]
|04 September 2024
|Possible DoS in X.509 name checks in OpenSSL

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:14.umtx.asc[FreeBSD-SA-24:14.umtx]
|04 September 2024
|umtx Kernel panic or Use-After-Free

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:15.bhyve.asc[FreeBSD-SA-24:15.bhyve]
|19 September 2024
|man:bhyve[8] out-of-bounds read access via XHCI emulation

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:16.libnv.asc[FreeBSD-SA-24:16.libnv]
|19 September 2024
|Integer overflow in libnv

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:17.bhyve.asc[FreeBSD-SA-24:17.bhyve]
|29 October 2024
|Multiple issues in the bhyve hypervisor

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:18.ctl.asc[FreeBSD-SA-24:18.ctl]
|29 October 2024
|Unbounded allocation in man:ctl[4] CAM Target Layer

|https://www.freebsd.org/security/advisories/FreeBSD-SA-24:19.fetch.asc[FreeBSD-SA-24:19.fetch]
|29 October 2024
|Certificate revocation list man:fetch[1] option fails

| https://www.freebsd.org/security/advisories/FreeBSD-SA-25:01.openssh.asc[FreeBSD-SA-25:01.openssh]
| 2025-01-29
| OpenSSH Keystroke Obfuscation Bypass

| https://www.freebsd.org/security/advisories/FreeBSD-SA-25:02.fs.asc[FreeBSD-SA-25:02.fs]
| 2025-01-29
| Buffer overflow in some filesystems via NFS

| https://www.freebsd.org/security/advisories/FreeBSD-SA-25:03.etcupdate.asc[FreeBSD-SA-25:03.etcupdate]
| 2025-01-29
| Unprivileged access to system files

| https://www.freebsd.org/security/advisories/FreeBSD-SA-25:04.ktrace.asc[FreeBSD-SA-25:04.ktrace]
| 2025-01-29
| Uninitialized kernel memory disclosure via man:ktrace[2]

| https://www.freebsd.org/security/advisories/FreeBSD-SA-25:05.openssh.asc[FreeBSD-SA-25:05.openssh]
| 2025-02-21
| Multiple vulnerabilities in OpenSSH
|===

[[errata]]
=== Errata Notices

[.informaltable]
[cols="1,1,1", frame="none", options="header"]
|===
| Errata
| Date
| Topic

|https://www.freebsd.org/security/advisories/FreeBSD-EN-23:15.sanitizer.asc[FreeBSDS-EN-23:15:sanitizer]
|01 December 2023
|Clang sanitizer failure with ASLR enabled

|https://www.freebsd.org/security/advisories/FreeBSD-EN-23:16.openzfs.asc[FreeBSDS-EN-23:16:openzfs]
|01 December 2023
|OpenZFS data corruption

|https://www.freebsd.org/security/advisories/FreeBSD-EN-23:17.ossl.asc[FreeBSDS-EN-23:17:ossl]
|05 December 2023
|man:ossl[4]'s AES-GCM implementation may give incorrect results

|https://www.freebsd.org/security/advisories/FreeBSD-EN-23:18.openzfs.asc[FreeBSDS-EN-23:18:openzfs]
|05 December 2023
|High CPU usage by ZFS kernel threads

|https://www.freebsd.org/security/advisories/FreeBSD-EN-23:19.pkgbase.asc[FreeBSDS-EN-23:19:pkgbase]
|05 December 2023
|Incorrect pkgbase version number for FreeBSD {releasePrev}.

|https://www.freebsd.org/security/advisories/FreeBSD-EN-23:20.vm.asc[FreeBSDS-EN-23:20:vm]
|05 December 2023
|Incorrect results from the kernel physical memory allocator

|https://www.freebsd.org/security/advisories/FreeBSD-EN-23:21.tty.asc[FreeBSDS-EN-23:21:tty]
|24 November 2023
|man:tty[4] IUTF8 causes a kernel panic

|https://www.freebsd.org/security/advisories/FreeBSD-EN-23:22.vfs.asc[FreeBSDS-EN-23:22:vfs]
|05 December 2023
|ZFS snapshot directories not accessible over NFS

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:01.tzdata.asc[FreeBSDS-EN-24:01:tzdata]
|14 February 2024
|Timezone database information update

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:02.libutil.asc[FreeBSDS-EN-24:02:libutil]
|14 February 2024
|Login class resource limits and CPU mask bypass

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:03.kqueue.asc[FreeBSDS-EN-24:03:kqueue]
|14 February 2024
|man:kqueue_close[2] page fault on exit using man:rfork[2]

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:04.ip.asc[FreeBSDS-EN-24:04:ip]
|14 February 2024
|Kernel panic triggered by man:bind[2]

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:05.tty.asc[FreeBSDS-EN-24:05:tty]
|28 March 2024
|TTY Kernel Panic

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:06.wireguard.asc[FreeBSDS-EN-24:06:wireguard]
|28 March 2024
|Insufficient barriers in WireGuard man:if_wg[4]

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:07.clang.asc[FreeBSDS-EN-24:07:clang]
|28 March 2024
|Clang crash when certain optimization is enabled

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:08.kerberos.asc[FreeBSDS-EN-24:08:kerberos]
|28 March 2024
|Kerberos segfaults when using weak crypto

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:09.zfs.asc[FreeBSDS-EN-24:09:zfs]
|24 April 2024
|High CPU usage by kernel threads related to ZFS

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:10.zfs.asc[FreeBSDS-EN-24:10:zfs]
|19 June 2024
|Kernel memory leak in ZFS

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:11.ldns.asc[FreeBSDS-EN-24:11:ldns]
|19 June 2024
|LDNS uses nameserver commented out in resolv.conf

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:12.killpg.asc[FreeBSDS-EN-24:12:killpg]
|19 June 2024
|Lock order reversal in killpg causing livelock

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:13.libc++.asc[FreeBSDS-EN-24:13:libc++]
|19 June 2024
|Incorrect size passed to heap allocated std::string delete

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:14.ifconfig.asc[FreeBSDS-EN-24:14:ifconfig]
|07 August 2024
|Incorrect ifconfig netmask assignment

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:15.calendar.asc[FreeBSDS-EN-24:15:calendar]
|04 September 2024
|man:cron[8] / man:periodic[8] session login

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:16.pf.asc[FreeBSDS-EN-24:16:pf]
|19 September 2024
|Incorrect ICMPv6 state handling in pf

|https://www.freebsd.org/security/advisories/FreeBSD-EN-24:17.pam_xdg.asc[FreeBSDS-EN-24:17:pam_xdg]
|20 October 2024
|XDG runtime directory's file descriptor leak at login

| https://www.freebsd.org/security/advisories/FreeBSD-EN-25:01.rpc.asc[FreeBSD-EN-25:01.rpc]
| 2025-01-29
| NULL pointer dereference in the NFSv4 client

| https://www.freebsd.org/security/advisories/FreeBSD-EN-25:02.audit.asc[FreeBSD-EN-25:02.audit]
| 2025-01-29
| System call auditing disabled by DTrace

| https://www.freebsd.org/security/advisories/FreeBSD-EN-25:03.tzdata.asc[FreeBSD-EN-25:03.tzdata]
| 2025-01-29
| Timezone database information update

| https://www.freebsd.org/security/advisories/FreeBSD-EN-25:04.tzdata.asc[FreeBSD-EN-25:04.tzdata]
| 2025-04-10
| Timezone database information update

| https://www.freebsd.org/security/advisories/FreeBSD-EN-25:05.expat.asc[FreeBSD-EN-25:05.expat]
| 2025-04-10
| Update expat to 2.7.1

| https://www.freebsd.org/security/advisories/FreeBSD-EN-25:06.daemon.asc[FreeBSD-EN-25:06.daemon]
| 2025-04-10
| man:daemon[8] missing signals

| https://www.freebsd.org/security/advisories/FreeBSD-EN-25:07.openssl.asc[FreeBSD-EN-25:07.openssl]
| 2025-04-10
| Update OpenSSL to 3.0.16

| https://www.freebsd.org/security/advisories/FreeBSD-EN-25:08.caroot.asc[FreeBSD-EN-25:08.caroot]
| 2025-04-10
| Root certificate bundle update
|===

[[userland]]
== Userland

This section covers changes and additions to userland applications, contributed software, and system utilities.

[[userland-config]]
=== Userland Configuration Changes

A new `kdc_restart` variable is available that manages man:kdc[8] (or `krb5kdc`) under man:daemon[8].
Set `kdc_restart="YES"` in man:rc.conf[5] to auto restart kdc on abnormal termination.
Set `kdc_restart_delay="N"` to the number of seconds to delay before restarting the kdc.
gitref:abc4b3088941[repository=src]

By default, changes shown in email by the man:periodic[8] facility from the `daily` scripts show less context than before to reduce the size of the output.
The behavior can be controlled by the `daily_diff_flags` variable in man:periodic.conf[5].
Similarly, the changes shown by the security scripts show less context than previously, controlled by the `security_status_diff_flags` variable in man:periodic.conf[5].
gitref:538994626b9f[repository=src], gitref:37dc394170a5[repository=src], gitref:128e78ffb084[repository=src]

[[userland-programs]]
=== Userland Application Changes

The man:adduser[8] utility, used by man:bsdinstall[8], will now create a ZFS dataset for a new user's home directory if the parent directory resides on a ZFS dataset.
A command-line option is available to disable use of a separate dataset.
ZFS encryption is also available.
gitref:516009ce8d38[repository=src]

The man:date[1] program now supports nanoseconds.
For example: `date -Ins` prints "2024-04-22T12:20:28,763742224+02:00" and `date +%N` prints "415050400".
gitref:eeb04a736cb9[repository=src]

The man:dtrace[1] utility can now generate machine-readable output in JSON, XML, and HTML using man:libxo[3].
gitref:aef4504139a4[repository=src] (Sponsored by Innovate UK)

The man:lastcomm[1] utility now displays timestamps with a precision of seconds.
gitref:692c0a2e80c1[repository=src] (Sponsored by DSS Gmbh)

The man:ldconfig[8] utility now supports hints files of either byte order.
The default format is the native byte-order of the host.
gitref:fa7b31166ddb[repository=src]

The man:usbconfig[8] utility now reads the descriptions of usb vendor and products from [.filename]#/usr/share/misc/usb_vendors# when available, similar to what man:pciconf[8] does.
gitref:7b9a772f9f64[repository=src]

An option has been added to change the directory in man:env[1] which closely resembles the feature in the GNU version of env although it does not support long options.
gitref:08e8554c4a39[repository=src] (Sponsored by Klara, Inc.)

Fix `-U` flag of man:ps[1] to select processes by real user IDs.
This is what POSIX mandates for option `-U` and arguably the behavior that most users actually need in most cases.
Before, `-U` would select processes by their effective user IDs (which is the behavior mandated by POSIX for option `-u`).
gitref:a2132d91739d[repository=src].
(Sponsored by The FreeBSD Foundation).

Make '-O' more versatile and predictable for man:ps[1].
The man:ps[1] display's list of columns is now first built without taking into account the `-O` options.
In a second step, all columns passed via `-O` are finally inserted after the built-so-far display's first PID column (if it exists, else at start), in their order of appearance as arguments to the `-O` options.
gitref:1fc8cb547cd4[repository=src].
(Sponsored by The FreeBSD Foundation).

Remove not-explicitly-requested columns with duplicate data in man:ps[1].
Before this change, when stacking up more columns in the display through command-line options, if user requested to add some "canned" display (through options `-j`, `-l`, `-u` or `-v`), columns in it that were "duplicates" of already requested ones (meaning that they share the same keyword, regardless of whether their headers have been customized) were in the end omitted.
gitref:7aa2f4826717[repository=src].
(Sponsored by The FreeBSD Foundation).

Add flags to filter jail prison and vnet variables in man:sysctl[8] output.
So users do not have to contact the source code to tell whether a variable is a jail prison / vnet one or not.
gitref:615c9ce250ee[repository=src].

man:grep[1] no longer follows symbolic links by default for recursive searches.
This matches the documented behavior in the manual page.
gitref:3a2ec5957ea9[repository=src]

[[userland-contrib]]
=== Contributed Software

One True Awk (man:awk[1]) has been updated to 2nd Edition, with new -csv support and UTF-8 support.
gitref:daf917daba9c[repository=src]

The man:sendmail[8] suite has been upgraded to version 8.18.1, addressing CVE-2023-51765.
gitref:58ae50f31e95[repository=src]

`bc` has been upgraded to 7.0.2.
gitref:90ea553a0d30[repository=src]

`libarchive` has been upgraded to 3.7.7.
gitref:2ae238160f20[repository=src]

`libcbor` has been upgraded to 0.11.0.
gitref:1755b9daa693[repository=src] (Sponsored by The FreeBSD Foundation)

`libcxxrt` has been upgraded to vendor snapshot 6f2fdfebcd62.
gitref:d0dcee46d971[repository=src]

`libfido2` has been upgraded to 1.14.0.
gitref:128bace5102e[repository=src] (Sponsored by The FreeBSD Foundation)

`libpcap` has been upgraded to 1.10.5.
gitref:26f21a6494b4[repository=src] (Sponsored by The FreeBSD Foundation)

`tcpdump` has been upgraded to 4.99.5.
gitref:ec3da16d8bc1[repository=src] (Sponsored by The FreeBSD Foundation)

`unbound` has been upgraded to 1.22.0.
gitref:0a096a7b3ae8[repository=src]

`llvm` has been upgraded to 19.1.7-0-gcd708029e0b2.
gitref:dc3f24ea8a25[repository=src]


man:zfs[8]: OpenZFS has been updated to zfs-2.2-release(2.2.7)(gitref:2ec8b6948070[repository=src]).

man:xz[1] has been updated to 5.8.1(gitref:9679eedea94c[repository=src]).

man:less[1] has been updated to v668(gitref:0bb4c188d363[repository=src]).

man:file[1] has been updated to 5.46(gitref:71c92e6b94f0[repository=src]).

man:expat[3] has been updated to 2.7.1(gitref:6f7ee9ac036e[repository=src]).

`tzdata` has been updated to 2025b(gitref:475082194ac8[repository=src]).

OpenSSH has been updated to 9.9p2(gitref:059b786b7db5[repository=src]).
(Sponsored by The FreeBSD Foundation).

OpenSSL has been updated to 3.0.16(gitref:cb29db243bd0[repository=src]).

`googletest` has been updated from 1.14.0 to 1.15.2(gitref:1d67cec52542[repository=src]).
One notable change is that GoogleTest 1.15.x now officially requires C++-14 (1.14.x required C++-11).

`spleen` has been updated to Spleen 2.1.0(gitref:26336203d32c[repository=src]).

[[userland-libraries]]
=== Runtime Libraries and API

The man:setusercontext[3] routine in `libutil` will now set the process priority (nice) from the [.filename]#.login.conf# file from the home directory under appropriate conditions, as well as the system man:login.conf[5].
The priority can now have the value `inherit`, indicating that the priority should be unchanged from that of the parent process.
Similarly, the umask can have the value `inherit`.
gitref:6f6186e19fe5[repository=src], gitref:a8c273b3c97f[repository=src], gitref:d2d66fedc418[repository=src] (Sponsored by Kumacom SAS)

Many string and memory operations in the C library now use SIMD (single instruction multiple data) extensions for improved performance when available on amd64 systems; see man:simd[7].
(Sponsored by The FreeBSD Foundation)

There is now a much better implementation of the 128-bit `tgammal` function in the math library, man:math[3], on platforms that support it.
gitref:8df6c930c151[repository=src]

man:fma[3] now returns correctly-signed zero when provided certain small inputs (as observed in the Python test suite).
gitref:dc39004bc670[repository=src]
(Sponsored by The FreeBSD Foundation)

The `cap_rights_is_empty` function has been added.
It reports whether a `cap_rights_t` has no rights set.
gitref:e77813f7e4a3[repository=src]
(Sponsored by The FreeBSD Foundation)

`libcxxrt` has been updated to upstream 6f2fdfebcd62(gitref:d9901a23bd2f[repository=src]).

[[userland-deprecated-programs]]
=== Deprecated Applications

man:fdisk[8] has been deprecated in favor of man:gpart[8] for a long time but has not been removed, running this application will show a warning to migrate to man:gpart[8].
gitref:3958be5c29da[repository=src] (Sponsored by The FreeBSD Foundation)

The accuracy of man:asinf[3] and man:acosf[3] has improved.
gitref:33c82f11c267[repository=src]

Update deprecation warning to note that man:gvinum[8] is removed in 15.0(gitref:dec497a9fcbf[repository=src]).

Deprecation notice for man:syscons[4] has been added.
man:syscons[4] is not compatible with UEFI, does not support UTF-8, and is Giant-locked.
There is no specific timeline yet for removing it, but support for the Giant lock is expected to go away in one or two major release cycles.
(gitref:8c922db4f3d9[repository=src]).
(Sponsored by The FreeBSD Foundation).

OpenSSH plans to remove support for the DSA signature algorithm in early 2025.

man:publickey[5] stuffs has been deprecated.
This uses DES and it is likely that nobody uses that in 2025.
(gitref:9197c04a251b[repository=src]).

[[cloud]]
== Cloud Support

This section covers changes in support for cloud environments.

{releaseCurrent} supports cloudinit, including the `nuageinit` startup script and support for a `config-drive` partition.
It is compatible with OpenStack and many hosting facilities.
See the https://cloud-init.io[cloud-init] web site and the commit messages,
gitref:16a6da44e28d[repository=src] gitref:227e7a205edf[repository=src]. (Sponsored by OVHCloud)

The FreeBSD project is now publishing OCI-compatible container images.
gitref:8a688fcc242e[repository=src]

The FreeBSD project is now publishing Oracle Cloud Infrastructure images.
See the
link:https://cloudmarketplace.oracle.com/marketplace/app/freebsd-release[Oracle Cloud Infrastructure FreeBSD Listing]
for more information.
gitref:77b296a2582b[repository=src]

The "shutdown" and "reboot" API in the Amazon EC2 cloud now work for arm64 instances.
Older instances upgraded to FreeBSD {releaseCurrent} will need to have `debug.acpi.quirks="8"` set in `/boot/loader.conf`.
gitref:28b881840df7[repository=src] (Sponsored by Amazon)

The FreeBSD projects now publishes "small" EC2 images; these are the "base" images minus debug symbols, tests, 32-bit libraries, the LLDB debugger, the Amazon SSM Agent, and the AWS CLI.
gitref:953142d6baf3[repository=src] (Sponsored by Amazon)

[[kernel]]
== Kernel

This section covers changes to kernel configurations, system tuning, and system control parameters that are not otherwise categorized.

[[kernel-general]]
=== General Kernel Changes

The `fpu_kern_enter` and `fpu_kern_leave` routines have been implemented for powerpc, allowing the use of man:ossl[4] crypto functions in the kernel that use floating point and vector registers.
gitref:91e53779b4fc[repository=src]

Support legacy PCI hotplug on arm64.
gitref:355f02cddbf0[repository=src].
(Sponsored by Arm Ltd).

Define a common 'mac' node for MAC's jail parameters for man:mac[3].
To be used by man:mac_do[4].
gitref:66fb52a27279[repository=src].
(Sponsored by The FreeBSD Foundation).

New `setcred()` system call and associated MAC hooks.
This new system call allows to set all necessary credentials of a process in one go: Effective, real and saved UIDs, effective, real and saved GIDs, supplementary groups and the MAC label.
Its advantage over standard credential-setting system calls (such as `setuid()`, `seteuid()`, etc.) is that it enables MAC modules, such as man:mac_do[4], to restrict the set of credentials some process may gain in a fine-grained manner.
gitref:c1d7552dddb5[repository=src].
(Sponsored by The FreeBSD Foundation).

Support multiple users and groups as single rule's targets in man:mac_do[4].
Supporting group targets is a requirement for man:mac_do[4] to be able to enforce a limited set of valid new groups passed to `setgroups()`.
Additionally, it must be possible for this set of groups to also depend on the target UID, since users and groups are quite tied in UNIX (users are automatically placed in only the groups specified through '/etc/passwd' (primary group) and '/etc/group' (supplementary ones)).
gitref:83ffc412b2e9[repository=src].
(Sponsored by The FreeBSD Foundation).

Teach man:sysctl[8] to attach and run itself in a jail.
This allows the parent jail to retrieve or set kernel state when child does not have man:sysctl[8] installed (for example light weighted OCI containers or slim jails).
This is especially useful when manipulating jail prison or vnet sysctls.
For example, `sysctl -j foo -Ja` or `sysctl -j foo net.fibs=2`.
gitref:8d5d7e2ba3a6[repository=src].

Enable vnet man:sysctl[9] variables to be loader tunable.
In gitref:3da1cf1e88f8[repository=src], the meaning of the flag `CTLFLAG_TUN` is extended to automatically check if there is a kernel environment variable which shall initialize the `SYSCTL` during early boot.
It works for all `SYSCTL` types both statically and dynamically created ones, except for the `SYSCTLs` which belong to VNETs.
Note that the implementation has a limitation.
It behaves the same way as that of non-vnet loader tunables.
That is, after the kernel or modules being initialized, any changes (for example via `kenv`) to kernel environment variable will not affect the corresponding vnet variable of subsequently created VNETs.
To overcome it, `TUNABLE_XXX_FETCH` can be used to fetch the kernel environment variable into those vnet variables during vnet constructing.
gitref:894efae09de4[repository=src]

man:sound[4]: Allocate vchans on-demand.
Refactor `pcm_chnalloc()` and merge with parts of `vchan_setnew()` (now removed) and `dsp_open()`’s channel creation into a `new dsp_chn_alloc()` function.
The function is responsible for either using a free HW channel (if `vchans` are disabled), or allocating a new vchan.
`hw.snd.vchans_enable` (previously `hw.snd.maxautovchans`) and `dev.pcm.X.{play|rec}.vchans` now work as tunables to only enable/disable `vchans`, as opposed to setting their number and/or (de-)allocating vchans.
Since these sysctls do not trigger any (de-)allocations anymore, their effect is instantaneous, whereas before it could have frozen the machine (when trying to allocate new vchans) when setting `dev.pcm.X.{play|rec}.vchans` to a very large value.
gitref:960ee8094913[repository=src].
(Sponsored by	The FreeBSD Foundation).

LinuxKPI: `linux_alloc_pages()` now honors `__GFP_NORETRY`.
This is to fix slowdowns with drm-kmod that get worse over time as physical memory become more fragmented (and probably also depending on other factors).
gitref:831e6fb0baf6[repository=src]
(Sponsored by The FreeBSD Foundation).

[[drivers]]
== Devices and Drivers

This section covers changes and additions to devices and device drivers since {releasePrev}.

[[drivers-device]]
=== Device Drivers

A driver is available for man:ice[4] Ethernet network controllers in the Intel E800 series, which support 100 Gb/s operation.
It was upgraded to version 1.43.2-k.
gitref:38a1655adcb3[repository=src] (Sponsored by Intel Corporation)

Numerous stability improvements have been in the man:iwlwifi[4] driver for Intel Wi-Fi devices.
(Sponsored by The FreeBSD Foundation)

Multiple PCI MCFG regions are now supported on amd64 and i386, allowing PCI configuration space access for domains (segments) other than 0.
gitref:4b5f64408804[repository=src]

The man:smsc[4] Ethernet driver can now fetch the value of `smsc95xx.macaddr` passed by some Raspberry Pi models and use it for the MAC address.
It always uses a stable MAC address even if there is no address in EEPROM.
gitref:028e4c6548e4[repository=src]

The `snd_clone` framework has been removed from the sound subsystem, including related sysctls, simplifying the system.
The per-channel nodes ([.filename]#/dev/dspX.Y#) are no longer created, just the primary device ([.filename]#/dev/dspX#).
gitref:e6c51f6db8d7[repository=src] (Sponsored by The FreeBSD Foundation)

Audio now supports asynchronous device detach.
This greatly simplifies hot plugging and unplugging of things such as USB headsets, and eases use of PulseAudio in cases that require operating system sleep and wake (suspend and resume).
gitref:d692c314d29a[repository=src] (Sponsored by The FreeBSD Foundation)

`ena` has been upgraded to 2.8.0.
gitref:6bf02434bd9a[repository=src] (Sponsored by Amazon, Inc.)

`ice_ddp` has been upgraded to 1.3.41.0.
gitref:a9d78bb714e3[repository=src] (Sponsored by Intel Corporation)

Tiger Lake-H support has been added to the man:hda[4] driver.
gitref:dbb6f488df6e[repository=src]

Meteor Lake support has been added to the man:ichsmb[4] driver.
gitref:14c22e28e4ee[repository=src]
(Sponsored by Framework Computer Inc)
(Sponsored by The FreeBSD Foundation)

Meteor Lake support has been added to the man:ig4[4] driver.
gitref:56f0fc0011c2[repository=src]

A new wireless driver supporting some Realtek chipsets is available: man:rtw89[4].
gitref:a2d1e07f6451[repository=src] (Sponsored by The FreeBSD Foundation)

Support for Realtek 8156/8156B has been moved from from man:cdce[4] to man:ure[4] for improved performance and reliability.
gitref:630077a84186[repository=src] (Sponsored by The FreeBSD Foundation)

Support for ACPI GPIO _AEI objects has been added.
gitref:1db6ffb2a482[repository=src] (Sponsored by Amazon)

man:nvme[4] and man:nvmecontrol[8] have been enabled on all architectures.
gitref:24687a65dd7f[repository=src], gitref:aba2d7f89dcf[repository=src]
(Sponsored by Chelsio Communications and Netflix)

man:mpi3mr[4] driver version has been updated to 8.14.0.2.0(gitref:e6d4b221ba7c[repository=src]).

man:mpi3mr[4] MPI Header has been updated to Version 36.
This aligns with the latest MPI specification.
This includes updated structures, field definitions, and constants required for compatibility with updated firmware.
(gitref:60cf1576501d[repository=src]).

The man:mpi3mr[4] driver is now in GENERIC (gitref:e2b8fb2202c2[repository=src]).

man:rtw88[4]: Merge Realtek's rtw88 driver based on Linux v6.14 (gitref:8ef442451791[repository=src]).
(Sponsored by The FreeBSD Foundation).

man:rtw89[4]: Merge Realtek's rtw89 driver based on Linux v6.14 (gitref:b6e8b845aeab[repository=src]).
(Sponsored by The FreeBSD Foundation).

man:iwmbtfw[4]: Add support for 9260/9560 bluetooth adaptors (gitref:8e62ae9693bd[repository=src]).
Required firmware files are already included in to package:comms/iwmbt-firmware[] port.

man:ena[4] driver version has been updated to v2.8.1 (gitref:a1685d25601e[repository=src]).
(Sponsored by Amazon, Inc.)

man:ix[4]: Add support for 1000BASE-BX SFP modules x550(gitref:24491b4acce5[repository=src]).

man:bnxt[4]: Enable NPAR support on BCM57504 10/25GbE NICs.
(gitref:54f842ed8897[repository=src]).

man:bnxt[4]: Add 5760X (Thor2) PCI IDs support.
Add Thor2 PCI IDs.
(gitref:45e161020c2d[repository=src]).

man:bnxt[4]: Add support for 400G speed modules (gitref:32fdad17f060[repository=src]).

man:ix[4]: Add support for 1000BASE-BX SFP modules.
Add support for 1Gbit BiDi modules.
(gitref:c34817d9aef7[repository=src]).

man:igc[4]: Fix attach for I226-K and LMVP devices.
The device IDs for these were in the driver's list of PCI ids to attach to, but `igc_set_mac_type()` had never been setup to set the correct mac type for these devices.
Fix this by adding these IDs to the switch block in order for them to be recognized by the driver instead of returning an error.
This fixes the man:igc[4] attach for the I226-K LOM on the ASRock Z790 PG-ITX/TB4 motherboard, allowing it to be recognized and used.
gitref:f034ddd2fa38[repository=src].

Remove old itr sysctl handler from man:em[4].
This implementation had various bugs.  The unit conversion/scaling was wrong, and it also did not handle 82574L or man:igb[4] devices correctly.
With the new AIM code, it is expected most users will not need to manually tune this.
gitref:edf50670e215[repository=src]
(Sponsored by	BBOX.io).

Added support for Brainboxes USB-to-Serial adapters in man:uftdi[4].
(gitref:47db906375b5[repository=src])

[[drivers-removals]]
=== Deprecated and Removed Drivers

man:agp[4] has been planned for removal in FreeBSD 15.0, and the man page now states that it is deprecated.
gitref:92af7c97e197[repository=src]

man:syscons[4] has been planned for removal in future releases, and has been noted as deprecated in the man pages to notify users to migrate to man:vt[4].
gitref:2bc5b1d60512[repository=src] (Sponsored by The FreeBSD Foundation)

[[storage]]
== Storage

This section covers changes and additions to file systems and other storage subsystems, both local and networked.

[[storage-nfs]]
=== NFS

The man:mountd[8] server has been modified to use man:strunvis[3] to decode directory names in man:exports[5] file(s).
This allows special characters, such as blanks, to be embedded in the directory name.
`vis -M` may be used to encode such directory names; see man:vis[1].
gitref:2c83f1ada435[repository=src]

New man:sysctl[8] variables have been added under `kern.rpc.unenc` and `kern.rpc.tls`, which allow an NFS server administrator to determine how much NFS-over-TLS is being used.
A large number of failed handshakes might indicate an NFS configuration problem.
gitref:b8e137d8d32d[repository=src]

[[storage-ufs]]
=== UFS

Soft updates are now enabled by default when creating a new UFS file system with man:newfs[8].
gitref:6b2af2d88ffd[repository=src]

[[storage-zfs]]
=== ZFS

[[storage-general]]
=== General Storage

Define a new `-a` command line option man:mountd[8].
When a file system was exported with the `-alldirs` flag, the export succeeded even if the directory path was not a server file system mount point.
gitref:ead3cd3ef628[repository=src]

Document recent file handle layout changes.
gitref:ca22082c01a7[repository=src]

Allow to pass `{NGROUPS_MAX} + 1` groups in man:mountd[8].
`NGROUPS_MAX` is just the minimum maximum of the number of allowed supplementary groups.
The actual runtime value may be greater.
Allow more groups to be specified accordingly (now that, a few commits ago, man:nmount[2] has been changed similarly).
gitref:ca9614d8f64a[repository=src]
(Sponsored by The FreeBSD Foundation).

[[boot-loader]]
== Boot Loader Changes

This section covers the boot loader, boot menu, and other boot-related changes.

The man:loader[8] now reads local configuration files listed in the variable `local_loader_conf_files` after other configuration files, defaulting to [.filename]#/boot/loader.conf.local#.
gitref:a25531db0fc2[repository=src]

The man:loader[8] can now be configured to read specific configuration files based on the planar maker, planar product, system product and uboot m_product variables from the SMBIOS.
For the moment, the best documentation is the git commit message,
gitref:3eb3a802a31b[repository=src].

Console detection in man:loader[8] has been improved on EFI systems.
If there is no ConOut variable, ConIn is checked.
If multiple devices are found, serial is preferred.
gitref:20a6f4779ac6[repository=src] (Sponsored by Netflix)

Frame buffer support in man:loader[8] can now use a text-only video driver, resulting in space savings.
gitref:57ca2848c0aa[repository=src] (Sponsored by Netflix)

The detection of ACPI is now done earlier in man:loader.efi[8] on arm64 systems.
The copy of [.filename]#loader.efi# on the EFI partition should be updated on arm64 systems using ACPI.
gitref:05cf4dda599a[repository=src] gitref:16c09de80135[repository=src]

The LinuxBoot loader can be used to boot FreeBSD from Linux on aarch64 systems as well as amd64.
gitref:46010641267[repository=src] (Sponsored by Netflix)

The BIOS boot loader added back support for gzip and bzip2, but removed support for graphics mode (by default) to address size problems.
(The EFI boot loader is unchanged with support for all of those.)
gitref:4d3b05a8530e[repository=src] (Sponsored by Netflix)

man:loader.efi[8]: Favor the v3 (64-bit) entry point in man:smbios[4].
Be consistent with what is done with non-EFI boot (but with the difference that EFI runs in 64-bit mode on 64-bit platforms, so there is no restriction that the v3 entry point should be below 4GB).
gitref:807d51be8040[repository=src].
(Sponsored by The FreeBSD Foundation).

man:libsa[3]: Favor the v3 (64-bit) entry point on non-EFI boot in man:smbios[4].
When both the 32-bit and 64-bit entry points are present, the SMBIOS specification says that the 64-bit entry point always has at least all the structures the 32-bit entry point refers.
In other words, the 32-bit entry point is provided for compatibility, so it is assumed the 64-bit one has more chances to be filled with adequate values.
gitref:93af0db0d529[repository=src]
(Sponsored by The FreeBSD Foundation).

man:libsa[3]: Use 64-bit entry point if table below 4GB on non-EFI boot in man:smbios[4].
On amd64, boot blocks and the non-EFI loader are 32-bit compiled as clients of BTX, so cannot access addresses beyond 4GB.
However, the 64-bit entry point may refer to a structure table below 4GB, which can be used if the BIOS does not provide a 32-bit entry point.
The situation is similar for powerpc64.
gitref:7b0350b376c0[repository=src].
(Sponsored by The FreeBSD Foundation).

Search for v3 (64-bit) entry point first on BIOS boot in man:smbios[4].
When booted from BIOS (i.e., not EFI), also search for a 64-bit version of the SMBIOS Entry Point.
This allows to detect and report the proper SMBIOS version with BIOSes that only provide the v3 table, as happens on Hetzner virtual machines.
For machines that provide both, leverage the v3 table in priority consistently with the EFI case.
gitref:145ef4af15f0[repository=src].
(Sponsored by The FreeBSD Foundation).
[[network]]
== Networking

This section describes changes that affect networking in FreeBSD.

[[network-protocols]]
=== Network Protocols

Lots of improvements to the network stack, including performance improvements and bug fixes for the man:sctp[4] stack.

Descriptors returned by man:sctp_peeloff[2] now inherit capabilities from the parent socket.
gitref:ae3d7e27abc9[repository=src]
(Sponsored by The FreeBSD Foundation)

[[network-general]]
=== General Network

ARP (man:arp[4]) support for 802-standard networks has been restored; it had been accidentally removed with FDDI support.
(This is different than the Ethernet standard encapsulation.)
gitref:d776dd5fbd48[repository=src]

It is possible to build a kernel with IPv6 support (INET6) without IPv4 (INET).
gitref:6df9fa1c6b83[repository=src] and others

The netgraph man:ng_ipfw[4] module no longer truncates cookies to 16 bits, allowing a full 32 bits.
gitref:dadf64c5586e[repository=src]

AIM(Adaptive Interrupt Moderation) support has been added to the man:igc[4] driver.
gitref:472a0ccf847a[repository=src] (Sponsored by Rubicon Communications, LLC ("Netgate") and BBOX.io)

This feature has also been added to the man:lem[4], man:em[4] and man:igb[4] drivers.  A major regression in UDP performance introduced in FreeBSD 12.0, including NFS over UDP, is believed to be fixed with this change.
gitref:49f12d5b38f6[repository=src] (Sponsored by Rubicon Communications, LLC ("Netgate") and BBOX.io)

Teach man:ip6addrctl[8] to attach and run itself in a jail.
This will make it easier to manage address selection policies of vnet jails, especially for those light weighted OCI containers or slim jails.
gitref:b709f7b38cc4[repository=src]

Convert `PF_DEFAULT_TO_DROP` into a vnet loader tunable 'net.pf.default_to_drop' for man:pf[4].
gitref:7f7ef494f11d[repository=src] introduced a compile time option `PF_DEFAULT_TO_DROP` to make the man:pf[4] default rule to drop.
While this change exposes a vnet loader tunable 'net.pf.default_to_drop' so that users can change the default rule without re-compiling the man:pf[4] module.
gitref:3965be101c43[repository=src]

[[wireless-networking]]
=== Wireless Networking

The LinuxKPI 802.11 comapt layer man:linuxkpi_wlan[4] gained support for the Galois/Counter Mode Protocol (GCMP) from man:wlan_gcmp[4]. (Sponsored by The FreeBSD Foundation)

The man:rtw88[4] driver was made to work (associate) again and a memory leak got resolved. (Sponsored by The FreeBSD Foundation)

Following other drivers man:iwlwififw[4] firmware was removed from the base system in favor of the ports based solution and man:fwget[8] support. (Sponsored by The FreeBSD Foundation)

[[hardware]]
== Hardware Support

This section covers general hardware support for physical machines, hypervisors, and virtualization environments, as well as hardware changes and updates that do not otherwise fit in other sections of this document.

Please see link:https://www.freebsd.org/releases/{localRel}R/hardware[the list of hardware] supported by {releaseCurrent}, as well as link:https://www.freebsd.org/platforms/[the platforms page] for the complete list of supported CPU architectures.

[[hardware-virtualization]]
=== Virtualization Support

The NVMM hypervisor is now detected.
gitref:34f40baca641[repository=src]

The VNC server in man:bhyve[8] will now show the correct colors when using the package:www/novnc[] client.
gitref:f9e09dc5b1d5[repository=src]

Under Hyper-V, TLB flushes are now performed using hypercalls rather than IPIs, providing up to a 40% improvement in TLB performance.
gitref:7ece5993b787[repository=src] (Sponsored by Microsoft)

Several bug fixes and configuration changes collectively allow device hotplug on both x86 and arm64 ("Graviton") EC2 instances.
Users upgrading EC2 instances from earlier FreeBSD releases should set `hw.pci.intx_reroute=0` and `debug.acpi.quirks="56"` in `/boot/loader.conf`.

[[linuxulator]]
=== Linux Binary Compatibility

The `AT_NO_AUTOMOUNT` flag is now ignored for all Linuxulator stat() variants (as the behavior specified by the flag already matches FreeBSD's), improving Linux application compatibility.
gitref:99d3ce80ba07[repository=src]
(Sponsored by The FreeBSD Foundation)

[[multimedia]]
== Multimedia

Many improvements to the audio stack including support for hot-swapping in man:mixer[8], and the addition of man:mididump[1].
gitref:cf9d2fb18433[repository=src] (Sponsored by The FreeBSD Foundation)
gitref:7224e9f2d4af[repository=src] (Sponsored by The FreeBSD Foundation)

[[documentation]]
== Documentation

This section covers changes to manual (man:man[1]) pages and other documentation shipped with the base system.

[[man-pages]]
=== Man Pages

A new man:networking[7] manual page provides a quickstart guide to connecting the system to networks including Wi-Fi, and links to other manual pages and the handbook.
gitref:39f92a4c4c49[repository=src]

Refer to man:graid[8] and man:zfs[8] instead of man:gvinum[8] in man:ccdconfig[8]).
(gitref:55cb3a33d920[repository=src]).

man:ps[1]: Document change in behavior for `-a`/`-A`.
Document the practical consequence of change gitref:93a94ce731a8[repository=src] that specifying `-a`/`-A` leads to printing all processes regardless of the presence of other process selection options (except for `-x`/`-X`, which command a filter).
gitref:eed005b57895[repository=src].
(Sponsored by The FreeBSD Foundation).

man:ps[1]: Change in behavior for option `-U`.
gitref:4e4739dd0745[repository=src]
(Sponsored by The FreeBSD Foundation).

man:ps[1]: Change of how current user's processes are matched.
gitref:7219648f60d1[repository=src].
(Sponsored by The FreeBSD Foundation).

man:ps[1]: Match current user's processes using effective UID.
This puts man:ps[1] of FreeBSD in conformance with POSIX.
gitref:1e8dc267ca91[repository=src].
(Sponsored by The FreeBSD Foundation).

man:mac_do[4]: Change of rules syntax; Provide hints and pointers.
gitref:0c3357dfa18f[repository=src].
(Sponsored by The FreeBSD Foundation).

man:firewire[4]: Add deprecation notice.
This was originally discussed as part of FreeBSD 15 planning, but did not happen in time.
Add the deprecation notice now, with an expectation that it will be removed before FreeBSD 16.
gitref:fc889167c319[repository=src].
(Sponsored by The FreeBSD Foundation).

The ethernet switch controllers, man:mtkswitch[4], man:ip17x[4], man:ar40xx[4], and man:e6000sw[4] have gained initial manual pages.

man:mount[8] has gained an example for remounting all filesystems read/write in single-user mode.

Manual pages for the lua man:loader[8] modules have had their desctiptions reworded to optimize man:apropos[1] results.

The manual pages style guide, man:style.mdoc[5], has gained a section for listing supported hardware.
When listed this way, the supported hardware will be listed in link:https://www.freebsd.org/releases/{localRel}R/hardware[the supported hardware notes].
Many manuals have had this section added or reworded in this release.

Much work has gone into adding man:sysctl[8]s and environment variables to the manual.
Try searching for them with `apropos Va=here.is.the.sysctl` or `apropos Ev=here_is_the_environment_variable`.

The man:intro[5] to the File Formats manual has been revised, incorporating improvements from OpenBSD.

[[ports]]
== Ports Collection and Package Infrastructure

This section covers changes to the FreeBSD Ports Collection, package infrastructure, and package maintenance and installation tools.


A new `FreeBSD-kmods` repository is included in the default `/etc/pkg/FreeBSD.conf` man:pkg[8] configuration file.
This repository contains kernel modules compiled specifically for {releaseCurrent} rather than for the {releaseBranch} branch.
Installing kernel modules from this repository allows drivers with unstable kernel interfaces, in particular graphics drivers, to work even when the main {releaseBranch} repository has packages build on a previous release. (gitref:a47542f71511[repository=src]).

[[Installer]]
=== Installer

The FreeBSD installer, man:bsdinstall[8], now supports downloading and installing firmware packages after the FreeBSD base system installation is complete.
gitref:03c07bdc8b31[repository=src] (Sponsored by The FreeBSD Foundation)

[[ports-packages]]
=== Packaging Changes

The package:net/wifi-firmware-kmod@release[] package has been added to the DVD package set in order to provide necessary firmware for wifi drivers.
gitref:8c6df7ead19c[repository=src] (Sponsored by The FreeBSD Foundation)

[[future-releases]]
== General Notes Regarding Future FreeBSD Releases
